// ver 6.8, changed i/o16 from XON/ XOFF single bit, to using 2 output ports,NOW i/o 16 is  XON ONLY and i/o 15 is XOFF only, active HIGH pulse.
// added output port 15 XOFF code ,active HIGH pulse


// U7
// ver 6.7 added HAMMER led logic, i/o 18 pin27  , and HAMMER INPUT i/o 19
// ver 6.6 fixed (-) (_) minus and underscore where backwards, (-) minus printed as underscore, fixed by removing shift bit on
//     ascii byte # 45 value 36 shift bit =1, and byte # 95 ascii value 36  shift bit =0.

// ver 6.5 fixed  XON  OFF printing error G when in local keyboard mode
// fixed the garbage XON/OFF by assigning 20 to  DC1 and DC3 ( char # 17 and 19 in ascii table

// 6.4 XON XOFF works great
// test Desklamp if still works

// ver 6.2 will attempt Xon Xoff functions . coulnd get it to work here in U7 so sending i/o pin 16 led to U5 i/o input
// need to reprogram U5 to accept PAUSE term from this U7 and send out XOFF/ XON terms on serial (done)
// Ver 6.0  Pause printing works
// Sept 10  2022
// added i/o 17 on pin 26, when carriage motor is active stop ( hold) printing.
// when the input is held LOW print will pause for 2 seconds,and then keep printing WORKS
// added i/o output 16  PAUSE led, when carriage motor is runing led = ON yellow

#include <SoftwareSerial.h>
SoftwareSerial Serial1(11,12); // move RX in pin 17 digital i/o 11, and TX on i/o 12 pin 18 

int value = 0;
int bcdPins[7] = { 3, 4, 5, 6 ,7, 8, 10};  //  3= i/o 3 pin 5 (MSB bit A), 4=i/o 4 pin6 (MSB bit B), 5= i/o 5 pin 11 (MSB bit C), 6=i/o 6 pin 12(LSB bit A), 7=i/o 7 pin 13(LSB bit B), 8= i/o 8 pin 14 (LSB bit C), 10= i/o 10 shift bit
int latchPin = 2;// LE (latch enable) i/o 2 pin 4
int bitsToSend = 0;
int Hammer_Led = 18;
int Hammer_Input = 19;
int Hammer_Val = 1;
const int buttonPin = 17;    //i/o 17 pin 26 as input term, carriage motor is active when HIGH hold data for printing
int buttonState = 0;         // current state of the button
int lastButtonState = 0;     // previous state of the button
const int ledPin16 =  16;      // i/o 16 pin 25 is now XON to U7 Pin i/o 17  Pulse when carriage motor is running, active LOW
const int ledPin15 =  15;      // i/o 16 pin 24 is now XOFF to U7 Pin i/o 16 , Pulse when carriage motor is stopping, active LOW
bool flowControl = false;

 byte bcdCode[][7] = { 
// upper case "shift" bit 7=0
//                     ascii value  function &  Cosmac Value
  { 0, 1, 0, 0, 0, 0, 0},// 0       // null // 20 dead not used
  { 0, 0, 0, 0, 0, 0, 0},// 1       // start of header
  { 0, 0, 0, 0, 0, 0, 0},// 2       // start of text
  { 0, 0, 0, 0, 0, 0, 0},// 3       // end of text
  { 0, 0, 0, 0, 0, 0, 0},// 4       // end of transimission
  { 0, 0, 0, 0, 0, 0, 0},// 5       // enquiry
  { 0, 0, 0, 0, 0, 0, 0},// 6       // ACK 
  { 0, 0, 0, 0, 0, 0, 0},// 7       // bell
  { 1, 0, 1, 1, 0, 1, 0},// 8       // backspace 55 (Not wired in??)
  { 1, 1, 1, 0, 0, 1, 0},// 9       // Hor tab 74
  { 0, 1, 0, 0, 1, 1, 0},// 10      // line feed // dead key for \n // 26 without this the \n will do the carriage return properly but add the letter G (0,0,0,0,0,0,0) at pos 1, because \n has 2 byte command
  { 0, 0, 0, 0, 0, 0, 0},// 11      // ver tab 74
  { 0, 0, 0, 0, 0, 0, 0},// 12      // form feed
  { 0, 1, 0, 0, 0, 1, 0},// 13      // CR \n // 24
  { 0, 0, 0, 0, 0, 0, 0},// 14      // shift out
  { 0, 0, 0, 0, 0, 0, 0},// 15      // shift in
  { 0, 0, 0, 0, 0, 0, 0},// 16      // data link escape
  { 0, 1, 0, 0, 0, 0, 0},// 17      // dev control 1 XON 20
  { 0, 0, 0, 0, 0, 0, 0},// 18      // dev cont 2
  { 0, 1, 0, 0, 0, 0, 0},// 19      // dev cont 3  XOFF 20
  { 0, 0, 0, 0, 0, 0, 0},// 20      // dev cont 4
  { 0, 0, 0, 0, 0, 0, 0},// 21      // Neg ack NACK 
  { 0, 0, 0, 0, 0, 0, 0},// 22      // synchronous idle
  { 0, 0, 0, 0, 0, 0, 0},// 23      // EOT , block
  { 0, 0, 0, 0, 0, 0, 0},// 24      // cancel
  { 0, 0, 0, 0, 0, 0, 0},// 25      // end of medium
  { 0, 0, 0, 0, 0, 0, 0},// 26      // substitute
  { 0, 0, 0, 0, 0, 0, 0},// 27      // escape
  { 0, 0, 0, 0, 0, 0, 0},// 28      // file separator
  { 0, 0, 0, 0, 0, 0, 0},// 29      // group separator
  { 0, 0, 0, 0, 0, 0, 0},// 30      // record separator
  { 0, 0, 0, 0, 0, 0, 0},// 31      // unit separator
 
  
  { 1, 1, 1, 0, 0, 0, 0},// 32      // space bar  // 70
  { 1, 1, 1, 1, 1, 1, 0},// 33      // ! // 77 + ( #1 )
  { 1, 1, 0, 0, 1, 0, 0},// 34      // " // 32
  { 0, 1, 0, 1, 1, 1, 0},// 35      // # // 27 + ( #3 )
  { 0, 0, 0, 1, 1, 1, 0},// 36      // $ // 07 + ( #4 )
  { 0, 0, 0, 0, 1, 1, 0},// 37      // % // 06 + ( #5 )
  { 1, 0, 0, 1, 1, 1, 0},// 38      // & // 17 + ( #7 )
  { 1, 1, 0, 0, 1, 0, 1},// 39      // ' // 32 
  { 1, 0, 1, 1, 1, 1, 0},// 40      // ( // 57
  { 1, 1, 0, 1, 1, 1, 0},// 41      // ) // 37
  { 0, 0, 1, 1, 1, 1, 0},// 42      // * // 47 + ( #8 )
  { 1, 0, 1, 0, 1, 1, 0},// 43      // + // 56
  { 0, 0, 1, 1, 0, 0, 0},// 44      // , coma //41
  { 1, 1, 0, 0, 1, 1, 1},// 45      // - // 36 + ( #-)
  { 1, 0, 1, 1, 0, 0, 0},// 46      // . // 51 period
  { 1, 1, 0, 1, 0, 0, 1},// 47      // / // 31 forwd slash
  
  // lower case "shift" bit 7=1
  { 1, 1, 0, 1, 1, 1, 1},// 48      // 0 // 37
  { 1, 1, 1, 1, 1, 1, 1},// 49      // 1 // 77
  { 0, 1, 1, 1, 1, 1, 1},// 50      // 2 // 67
  { 0, 1, 0, 1, 1, 1, 1},// 51      // 3 // 27
  { 0, 0, 0, 1, 1, 1, 1},// 52      // 4 // 07
  { 0, 0, 0, 0, 1, 1, 1},// 53      // 5 // 06
  { 1, 0, 0, 0, 1, 1, 1},// 54      // 6 // 16
  { 1, 0, 0, 1, 1, 1, 1},// 55      // 7 // 17
  { 0, 0, 1, 1, 1, 1, 1},// 56      // 8 // 47
  { 1, 0, 1, 1, 1, 1, 1},// 57      // 9 // 57
  // upper case "shift" bit 7=0
  
   { 1, 1, 0, 1, 1, 0, 0},// 58     // : colon 33
   { 1, 1, 0, 1, 1, 0, 1},// 59     // ; semi colon 33 and shift
   { 0, 0, 1, 1, 0, 0, 0},// 60     // < less than 41
   { 1, 0, 1, 0, 1, 1, 1},// 61     // = // 56 equal  
   { 1, 0, 1, 1, 0, 0, 0},// 62     // > // 51 greater than 
   { 1, 1, 0, 1, 0, 0, 0},// 63     // ? // 31
   { 0, 1, 1, 1, 1, 1, 0},// 64     // @ // 67 ( #2 )

  { 1, 1, 1, 1, 1, 0, 0},// 65      // A // 73 
  { 0, 0, 0, 0, 1, 0, 0},// 66      // B // 02 
  { 0, 1, 0, 1, 0, 0, 0},// 67      // C // 21 
  { 0, 1, 0, 1, 1, 0, 0},// 68      // D // 23 
  { 0, 1, 0, 1, 0, 1, 0},// 69      // E // 25 
  { 0, 0, 0, 1, 1, 0, 0},// 70      // F // 03 
  { 0, 0, 0, 0, 0, 0, 0},// 71      // G // 00 
  { 1, 0, 0, 0, 0, 0, 0},// 72      // H // 10 
  { 0, 0, 1, 1, 0, 1, 0},// 73      // I // 45 
  { 1, 0, 0, 1, 1, 0, 0},// 74      // J // 13 
  { 0, 0, 1, 1, 1, 0, 0},// 75      // K // 43 
  { 1, 0, 1, 1, 1, 0, 0},// 76      // L // 53 
  { 1, 0, 0, 1, 0, 0, 0},// 77      // M // 11 
  { 1, 0, 0, 0, 1, 0, 0},// 78      // N // 12 
  { 1, 0, 1, 0, 1, 0, 0},// 79      // O // 52 
  { 1, 1, 0, 0, 0, 1, 0},// 80      // P // 34 
  { 1, 1, 1, 1, 0, 1, 0},// 81      // Q // 75 
  { 0, 0, 0, 1, 0, 1, 0},// 82      // R // 05 
  { 0, 1, 1, 1, 1, 0, 0},// 83      // S // 63 
  { 0, 0, 0, 0, 0, 1, 0},// 84      // T // 04 
  { 1, 0, 0, 1, 0, 1, 0},// 85      // U // 15 
  { 0, 0, 0, 1, 0, 0, 0},// 86      // V // 01 
  { 0, 1, 1, 1, 0, 1, 0},// 87      // W // 65 
  { 0, 1, 1, 1, 0, 0, 0},// 88      // X // 61 
  { 1, 0, 0, 0, 0, 1, 0},// 89      // Y // 14 
  { 1, 1, 1, 1, 0, 0, 0},// 90      // Z // 71 
  
 // LOWER CASE bit 7 = 1 
  { 0, 1, 0, 0, 0, 0, 1},// 91      // [ // 20  NOT USED // 20 to disable
  { 0, 1, 0, 0, 0, 0, 1},// 92      // \ // 20 back slash NOT USED 20 disable
  { 0, 1, 0, 0, 0, 0, 1},// 93      // ] // 20 NOT USED // 20 to disable
  { 1, 0, 0, 0, 1, 1, 0},// 94      // ^ // 16 causes C with line
  { 1, 1, 0, 0, 1, 1, 0},// 95      // _ // 36 underscore
  { 0, 1, 0, 0, 0, 0, 1},// 96      // `//  20  Accent grave  20 to disable
 
// LOWER CASE bit 7 = 1               lowercase letters
  { 1, 1, 1, 1, 1, 0, 1},// 97       // A // 73 +
  { 0, 0, 0, 0, 1, 0, 1},// 98       // B // 02 +
  { 0, 1, 0, 1, 0, 0, 1},// 99       // C // 21 +
  { 0, 1, 0, 1, 1, 0, 1},// 100      // D // 23 +
  { 0, 1, 0, 1, 0, 1, 1},// 101      // E // 25 +
  { 0, 0, 0, 1, 1, 0, 1},// 102      // F // 03 +
  { 0, 0, 0, 0, 0, 0, 1},// 103      // G // 00 +
  { 1, 0, 0, 0, 0, 0, 1},// 104      // H // 10 +
  { 0, 0, 1, 1, 0, 1, 1},// 105      // I // 45 +
  { 1, 0, 0, 1, 1, 0, 1},// 106      // J // 13 +
  { 0, 0, 1, 1, 1, 0, 1},// 107      // K // 43 +
  { 1, 0, 1, 1, 1, 0, 1},// 108      // L // 53 +
  { 1, 0, 0, 1, 0, 0, 1},// 109      // M // 11 +
  { 1, 0, 0, 0, 1, 0, 1},// 110      // N // 12 +
  { 1, 0, 1, 0, 1, 0, 1},// 111      // O // 52 +
  { 1, 1, 0, 0, 0, 1, 1},// 112      // P // 34 +
  { 1, 1, 1, 1, 0, 1, 1},// 113      // Q // 75 +
  { 0, 0, 0, 1, 0, 1, 1},// 114      // R // 05 +
  { 0, 1, 1, 1, 1, 0, 1},// 115      // S // 63 +
  { 0, 0, 0, 0, 0, 1, 1},// 116      // T // 04 +
  { 1, 0, 0, 1, 0, 1, 1},// 117      // U // 15 +
  { 0, 0, 0, 1, 0, 0, 1},// 118      // V // 01 +
  { 0, 1, 1, 1, 0, 1, 1},// 119      // W // 65 +
  { 0, 1, 1, 1, 0, 0, 1},// 120      // X // 61 +
  { 1, 0, 0, 0, 0, 1, 1},// 121      // Y // 14 +
  { 1, 1, 1, 1, 0, 0, 1},// 122      // Z // 71 +
 // upper case "shift" bit 7=0
  { 0, 1, 0, 0, 0, 0, 1},// 123      // { // 20 NOT USED 
  { 0, 1, 0, 0, 0, 0, 1},// 124      // | // 20 NOT USED 
  { 0, 1, 0, 0, 0, 0, 1},// 125      // } // 20 NOT USED 
  { 0, 1, 0, 0, 0, 0, 1},// 126      // ~ // 20 not used TILDY
  { 1, 1, 0, 0, 0, 0, 1},// 127      // DEL // 30 COR
  };
void setup(){
 // initialize the button pin as a input:
  pinMode(buttonPin, INPUT); // aka PAUSE input fom carriage motor term
  pinMode(ledPin16, OUTPUT); // XON to U7
  pinMode(ledPin15, OUTPUT); // XOFF to U7
   pinMode(Hammer_Led, OUTPUT); // Hammed LED
   pinMode(Hammer_Input, INPUT); // Hammer input from Q3 
  // Serial.begin(9600);
  Serial.begin(300,SERIAL_7N1);
  Serial.println("   Hello   world  ?      "); // say this on desklamp display
  Serial.write(0x11);// xon
  Serial1.begin(300);  // port 1 set up ( serial  TX to desklamp and Speech unit
  //Serial1.println("   Hello   world  ?      "); // say this on desklamp display
  
 for (int i=0; i < 7; i++){ // sets up the output pins // was 6
  pinMode(bcdPins[i], OUTPUT);}// setup the output pins
  pinMode(latchPin, OUTPUT);// set ups the latch as an output pin
  digitalWrite(latchPin, HIGH);   // initialize LE input on 4511 to high.(blank display)
  pinMode(10, OUTPUT);} // i/o pin 10 shift bit as output  

void loop(){
   buttonState = digitalRead(buttonPin);

  // compare the buttonState to its previous state
  if (buttonState != lastButtonState) {
    // if the state has changed, increment the counter
    if (buttonState == HIGH) {
      //Serial.write(0x13);// xoff // disabled because function moved to U5
      digitalWrite(ledPin16, HIGH);// turn ON XON at U7 input
      digitalWrite(ledPin16, HIGH);//  turn ON XON at U7 input
      digitalWrite(ledPin16, LOW);//  turn OFF XON at U7 input
    } else {
      //Serial.write(0x11);// xon // disabled because function moved to U5
      digitalWrite(ledPin15, HIGH); // turn ON XOFF at U7 input
      digitalWrite(ledPin15, HIGH); // turn ON XOFF at U7 input
      digitalWrite(ledPin15, LOW); // turn OFF XOFF at U7 input
    }
    // Delay a little bit to avoid bouncing
    delay(4);
  }
  // save the current state as the last state, for next time through the loop
  lastButtonState = buttonState;

  if (Serial.available() > 0) {
     bitsToSend  = Serial.read();
     Serial1.write( bitsToSend );// send incomming to desklamp display
     value = bitsToSend; 
     for (int i=0; i < 7; i++){
     digitalWrite(bcdPins[i], bcdCode[value][i]);}// print incomming to TTY

     digitalWrite(latchPin, LOW);   // Strobe the 4511 LE input to store bcd value
     delay(40);// was 40 30
     digitalWrite(latchPin, HIGH);
  }
  Hammer_Val = digitalRead (Hammer_Input);
  digitalWrite (Hammer_Led,! Hammer_Val);
   
   }
